; code :)
Code    SEGMENT
        ASSUME  CS:Code,DS:Code

        org     100h
.8086                          ; it runs even on 8086 !!! (for SURE)
_begin:
        jmp     _start

oldint08 DW 0,0
imhere DB 0

int08h:
        cmp     cs:imhere,0
        jnz     gotobios
        mov     cs:imhere,1

        push ax bx cx dx

; set VGA screen offset to 0 (page 0 X-mode)
; we just couldn't find any interesting things on page 1 ...
        xor     bx,bx
        xor     ax,ax

        mov     dx,3d4h
        mov     al,0dh
        mov     ah,bl
        out     dx,ax
        mov     al,0ch
        mov     ah,bh
        out     dx,ax

        mov     dx,3c0h
        mov     al,33h
        out     dx,al
        mov     al,0
        out     dx,al

; test lamer inputs
        in      al,60h
        cmp     al,1fh          ; 's'
        jz      timset

timret:
        in      al,60h
        cmp     al,3ah          ; CAPS lock
        jz      clearscreen
testslowmotion:
        mov     ax,3            ; right mouse button
        int     33h
        test    bl,2
        jnz     slowmotion

end08:
        pop     dx cx bx ax
gotobios:
; we love BIOS, don't we?
        mov     cs:imhere,0
        jmp     DWORD PTR cs:oldint08

slowmotion:
        mov bx,10                       ; the bigger the slower
xoxo2:
        mov cx,2000h                    ; the bigger the slower
xoxo:
        in      al,60h          ; 81920 times IN al,60h  ... kewl
        loop    xoxo            ; set to 16739267 for Pentiums .. hehe
        dec     bx              ; ^^^ not tested!!!
        jnz     xoxo2      ; these settings work for non-cached 386DX/15 :)))
        jmp     end08

clearscreen:
        push    es di
        mov     dx,3c4h
        mov     ax,0f02h
        out     dx,ax

        mov     ax,0a000h
        xor     di,di
        mov     es,ax
        xor     ax,ax
        cld
        mov     cx,4000h
        rep     stosw           ; i use stosw for compatibility reasons
        pop     di es           ; 8086 rulez!

        jmp     testslowmotion

timset:
        cli
        mov     al,34h
        out     43h,al
        mov     ax,2193          ; set timer to 500Hz
        out     40h,al           ; max. recommended value cca 800
        mov     al,ah
        out     40h,al
        sti
        jmp     timret

; REAL start
_start:
        push    cs
        pop     ds

        mov     imhere,0

        mov     ax,3508h
        int     21h
        mov     oldint08+2,es
        mov     oldint08,bx

        mov     ax,2508h
        mov     dx,OFFSET int08h
        int     21h

        mov     dx,OFFSET _start
        sub     dx,OFFSET _begin
        mov     bx,dx                   ; dead code
        mov     ah,31h
        int     21h

Code ENDS
END _begin
