
#include "dvlgfx.h"
#include <math.h>

#define d2r(rd)         ((rd)*3.141592654/128)
#define DISTX           256     /* 277 */
#define DISTY           256     /* 173 */
#define ROT             6

void main()
{
        float   Tcos[256],Tsin[256],scale=1;
        int     xnews[8],ynews[8];
        long
                xp[8],yp[8],zp[8],      /* 8 stored points */
                bx,by,bz,               /* Current cordinates */
                rx,ry,rz,               /* Pre-rotated points */
                rrx,rry,rrz,            /* Total rotated points */
                xnew,ynew,znew,         /* New points */
                point,point2,
                xo,yo;

        unsigned char
                xang,yang,zang,         /* Angles */
                done=0,
                color,colors,demo=1,choice,choice2,randnum=64;

        srand((unsigned)time(NULL));
        printf("Cube rotation demo - Djgpp version\n");
        printf("By Dhonn Lushine 1996  Ludhonn@aol,com: compiled on %s %s\n\n",__TIME__,__DATE__);
        printf("Turn Numlock on\nArrow keys\tRotate\n8\tMove ojbect up\n2\tMove ojbect down\n");
        printf("4\tMove ojbect left\n6\tMove ojbect right\n");
        printf("1\tRotate Z-axis left\n3\tRotate Z-axis right\n7\tScale back\n9\tScale forward\n");
        printf("5\tInc colors\nEsc\tQuit\n\nPress any key to continue...\n");

        if(getch()==0x01b) return;
	setvideo(0x13);

        for(point=0;point<256;point++)
        {
                Tcos[point]=cos(d2r(point));
                Tsin[point]=sin(d2r(point));
        }
        
        xp[0]=50;
        yp[0]=50;
        zp[0]=50;
        xp[1]=50;
        yp[1]=50;
        zp[1]=-50;
        xp[2]=50;
        yp[2]=-50;
        zp[2]=-50;
        xp[3]=50;
        yp[3]=-50;
        zp[3]=50;
        xp[4]=-50;
        yp[4]=-50;
        zp[4]=50;
        xp[5]=-50;
        yp[5]=50;
        zp[5]=50;
        xp[6]=-50;
        yp[6]=50;
        zp[6]=-50;
        xp[7]=-50;
        yp[7]=-50;
        zp[7]=-50;

	xang=0;
	yang=0;
        zang=0;

        xo=0;
        yo=0;

        colors=64;

        while(!done)
        {
		for(point=0;point<8;point++)
		{
                        bx=xp[point]*scale;
                        by=yp[point]*scale;
                        bz=zp[point]*scale; 


                        /* Rotate y */
                        rx = Tcos[yang] * bx + Tsin[yang] * bz;
                        rz = -Tsin[yang] * bx + Tcos[yang] * bz;

                                    
                      
                        /* Rotate x */
                        ry = Tcos[xang] * by - Tsin[xang] * rz;
                        rrz = Tsin[xang] * by + Tcos[xang] * rz;


                        /* Rotate z */  
                        rrx = Tcos[zang] * rx - Tsin[zang] * ry;
                        rry = Tsin[zang] * rx + Tcos[zang] * ry;


                        /* Add perspective */                     
                        xnew=(rrx+xo)*DISTX/(DISTX+rrz)+160;
                        ynew=-(rry+yo)*DISTY/(DISTY+rrz)+100;
                         
                        xnews[point]=xnew;
                        ynews[point]=ynew;
		}

                color=colors;
                lineb(xnews[0],ynews[0],xnews[5],ynews[5],color++);
                lineb(xnews[5],ynews[5],xnews[4],ynews[4],color++);
                lineb(xnews[4],ynews[4],xnews[3],ynews[3],color++);
                lineb(xnews[3],ynews[3],xnews[0],ynews[0],color++);
                lineb(xnews[1],ynews[1],xnews[2],ynews[2],color++);
                lineb(xnews[2],ynews[2],xnews[7],ynews[7],color++);
                lineb(xnews[7],ynews[7],xnews[6],ynews[6],color++);
                lineb(xnews[6],ynews[6],xnews[1],ynews[1],color++);
                lineb(xnews[0],ynews[0],xnews[1],ynews[1],color++);
                lineb(xnews[5],ynews[5],xnews[6],ynews[6],color++);
                lineb(xnews[4],ynews[4],xnews[7],ynews[7],color++);
                lineb(xnews[3],ynews[3],xnews[2],ynews[2],color++);

		vsync();
		blit(0);

                if(kbhit())
                {
                        switch(getch())
			{
                                case 0x01b:     done=1;
                                                break;
                                case 0:
                                switch(getch())
                                {
                                        case 0x50:      xang-=ROT;
                                                        break;
                                        case 0x48:      xang+=ROT;
                                                        break;
                                        case 0x4b:      yang+=ROT;
                                                        break;
                                        case 0x4d:      yang-=ROT;
                                                        break;
                                }               break;
                                case '3':       zang+=ROT;
                                                break;
                                case '1':       zang-=ROT;
                                                break;
                                case '8':       yo+=ROT;
                                                break;
                                case '2':       yo-=ROT;
                                                break;
                                case '4':       xo-=ROT;
                                                break;
                                case '6':       xo+=ROT;
                                                break;
                                case '7':       scale-=.02;
                                                break;
                                case '9':       scale+=.02;
                                                break;
                                case '5':       colors++;
                                                break;
                                case '.':       demo=!demo;
                                                break;
                                case '0':       xang=0;
                                                yang=0;
                                                zang=0;
                                                break;
                                case ']':       randnum++;
                                                break;
                                case '[':       randnum--;
                                if(!randnum) randnum=1;
                        }
                }
                if(demo)
                {
                        if(!(int)(rand()%randnum))choice=!choice;
                        if(!(int)(rand()%randnum))choice2=!choice2;
                        if(choice)xang++;else xang--;
                        if(choice2)yang++;else yang--;          
                }
	}	
	setvideo(0x03);
}

