#include <math.h>
#include <conio.h> 
#include <alloc.h>
#include <mem.h>
#include <time.h>
#include <stdlib.h>
#include <stdio.h>

#define r2d(rd)         ((rd)*3.141592654/128)
#define DISTX           256     /* 277 */
#define DISTY           256     /* 173 */
#define DISTPERSPECTIVE(screen,degrees) (((screen)/2)/(tan((deg)/2)))

char far*double_buffer;
char far*video_buffer=(char far*)0xa0000000l;
char far* z_buffer;
int r,g,b;

void clrmem(char far* mem,char value)
{asm{
        push    es
        les     di,mem
        mov     cx,32000
        mov     ah,value
        mov     al,ah
        cld
        rep     stosw
        pop     es
}}

void pageit(char col)
{asm{
        mov     dx,03dah
one:    in      al,dx
        test    al,8
        jne     one
two:    in      al,dx
        test    al,8
        je      two
        push    ds
        push    es
        mov     cx,32000
        les     di,video_buffer
        lds     si,double_buffer
        cld
        rep     movsw
        pop     es
        pop     ds
        push    es
        les     di,double_buffer
        mov     cx,32000
        mov     ah,col
        mov     al,ah
        cld
        rep     stosw
        pop     es
}}

void LineFG(int x1,int c1,int x2,int c2,int y)
{
        int i,yadr=(y<<8)+(y<<6),nc;
        long col,cc;
        if(x1>x2)
        {
         i=x1;
         x1=x2;
         x2=i;
         i=c1;
         c1=c2;
         c2=i;
        }
        if(x2==x1)return;
        if(c1==0) c1=1;
        col=(long)c1<<16;
        cc=(long)(c2-c1)<<16;
        cc/=(x2-x1);
        for(i=x1;i<=x2;i++)
        {
         nc=-(col>>16);
         asm{
          mov     cx,nc
          cmp     cx,0
          jl      zit
          cmp     cx,127
          jg      zit    
          mov     dx,yadr                     
          add     dx,i
          les     bx,z_buffer
          add     bx,dx
          mov     al,byte ptr es:[bx]
          cmp     al,cl
          jg      zit       
          mov     es:[bx],cl
          les     bx,double_buffer
          add     bx,dx     
          mov     es:[bx],cl
         zit:
         }
        col+=cc;
        }        
}

void TriangleG(int x1,int y1,int c1,int x2,int y2,int c2,int x3,int y3,int c3)
{
        int i;
        unsigned long eg1,eg2,dx1,dx2,col1,col2,cdx1,cdx2;

        if(y3<y1)
        {
                i=y1;     
                y1=y3;
                y3=i;
                i=x1;
                x1=x3;
                x3=i;
                i=c1;
                c1=c3;
                c3=i;
        }

        if(y2<y1)
        {
                i=y1;       
                y1=y2;
                y2=i;
                i=x1;
                x1=x2;
                x2=i;
                i=c1;
                c1=c2;
                c2=i;
        }

        if(y3<y2)
        {
                i=y2;
                y2=y3;
                y3=i;
                i=x2;
                x2=x3;
                x3=i;
                i=c2;
                c2=c3;
                c3=i;
        }

        if(!(y3 - y1)) return;
        dx1 = ((float)(x3-x1)/(y3-y1))*65536;             
        cdx1= ((float)(c3-c1)/(y3-y1))*65536; 
        eg1 = (long)x1<<16;
        eg2 = eg1;
        col1= (long)c1<<16;
        col2= col1;
        i = y1;
        if(y2-y1)
        {
                dx2=((float)(x2-x1)/(y2-y1))*65536;
                cdx2=((float)(c2-c1)/(y2-y1))*65536;

                for(i=y1;i<y2;i++)
                {
                        LineFG(eg1>>16,col1>>16,eg2>>16,col2>>16,i);
                        eg1+=dx1;
                        eg2+=dx2;
                        col1+=cdx1;
                        col2+=cdx2;
                }
        }
        else
        {
                eg2=(long)x2<<16;
                col2=(long)c2<<16;
        }
                       
        if(y3-y2)
        {
                dx2=((float)(x3-x2)/(y3-y2))*65536;
                cdx2=((float)(c3-c2)/(y3-y2))*65536;

                for(i=y2;i<y3;i++)
                {
                        LineFG(eg1>>16,col1>>16,eg2>>16,col2>>16,i);
                        eg1+=dx1;
                        eg2+=dx2;
                        col1+=cdx1;
                        col2+=cdx2;
                }
        }
}


void main()
{
        char pal[512*3];      


        int   Tcos[256],Tsin[256];
        int     xnews[8],ynews[8],znews[8];
        int
                xp[8],yp[8],zp[8],      /* 8 stored points */
                bx,by,bz,               /* Current cordinates */
                rx,ry,rz,               /* Pre-rotated points */
                rrx,rry,rrz,            /* Total rotated points */
                xnew,ynew,znew,         /* New points */
                point,point2,
                xo,yo,scale=0,aeffect=1,ROT=4;
                                          
        unsigned char
                xang,yang,zang,         /* Angles */
                done=0,
                color,colors,demo=0,choice,choice2,randnum=64,aliasing=0,option;

        srand((unsigned)time(NULL));
        printf("Gouraud Shaded,Z-buffered Cube rotation demo\n");
        printf("By Dhonn Lushine 1996 Ludhonn@aol.com: compiled on %s %s\n",__TIME__,__DATE__);
        printf("Mouse required.  Press esc if you don't have one.\n");
        printf("Press any key to continue...\n");
        if(getch()==0x01b) return;
        if((double_buffer=farmalloc(0xffff))==NULL)
        {
                printf("Memory allocation error");
                getch();
                return;
        }
        if((z_buffer=farmalloc(0xffff))==NULL)
        {
                printf("Memory allocation error");
                farfree(video_buffer);
                getch();
                return;

        }
        _fmemset(z_buffer,0xff,0xffff);
        _fmemset(double_buffer,0xff,0xffff);
        for(point=0;point<256;point++)
        {
                Tcos[point]=256*cos(r2d(point));
                Tsin[point]=256*sin(r2d(point));
        }
     
        asm{
        mov ax,13h
        int 10h
        }
        for(point=0;point<256;point++)
        {
         outp(0x3c6,0xff);
         outp(0x3c8,point);
         outp(0x3c9,0);
         outp(0x3c9,point>>2);
         outp(0x3c9,point>>1);
        }   

        /* outportb(0x3C2, 0xE3); */

        xp[0]=50;
        yp[0]=50;
        zp[0]=50;
        xp[1]=50;
        yp[1]=50;
        zp[1]=-50;
        xp[2]=50;
        yp[2]=-50;
        zp[2]=-50;
        xp[3]=50;
        yp[3]=-50;
        zp[3]=50;
        xp[4]=-50;
        yp[4]=-50;
        zp[4]=50;
        xp[5]=-50;
        yp[5]=50;
        zp[5]=50;
        xp[6]=-50;
        yp[6]=50;
        zp[6]=-50;
        xp[7]=-50;
        yp[7]=-50;
        zp[7]=-50;
      /*  for(point=0;point<8;point++)
        {
         xp[point]/=1.5;
         yp[point]/=1.5;
         zp[point]/=1.5;
        }*/    
	xang=0;
	yang=0;
        zang=0;

        xo=0;
        yo=0;

        colors=0;
        scale=-28;
       

       // outportb(0x3c2,0xe3);
    /*   asm{
        mov al,0e3h
        mov dx,3c2h
        out dx,al
        }        */
       
        while(!done)
        {
		for(point=0;point<8;point++)
		{
                        bx=xp[point];
                        by=yp[point];
                        bz=zp[point]; 


                        /* Rotate y */
                        rx = (Tcos[yang] * bx + Tsin[yang] * bz)>>8;
                        rz = (-Tsin[yang] * bx + Tcos[yang] * bz)>>8;

                                    
                      
                        /* Rotate x */
                        ry = (Tcos[xang] * by - Tsin[xang] * rz)>>8;
                        rrz = (Tsin[xang] * by + Tcos[xang] * rz)>>8;


                        /* Rotate z */  
                        rrx = (Tcos[zang] * rx - Tsin[zang] * ry)>>8;
                        rry = (Tsin[zang] * rx + Tcos[zang] * ry)>>8;


                        rrz+=scale;

                        /* Add perspective */
                        if(DISTX+rrz)
                        {
                        xnew=(rrx+xo)*DISTX/(DISTX+rrz)+160;
                        ynew=-(rry+yo)*DISTX/(DISTX+rrz)+100;
                        } 
                        xnews[point]=xnew;
                        ynews[point]=ynew;
                        znews[point]=rrz;
		}

                color=colors;
                {
                static int x0,x1,x2,x3,x4,x5,x6,x7,y0,y1,y2,y3,y4,y5,y6,y7,z0,z1,z2,z3,z4,z5,z6,z7;

                x0=xnews[0];
                x1=xnews[1];
                x2=xnews[2];
                x3=xnews[3];
                x4=xnews[4];
                x5=xnews[5];
                x6=xnews[6];
                x7=xnews[7];
                y0=ynews[0];
                y1=ynews[1];
                y2=ynews[2];
                y3=ynews[3];
                y4=ynews[4];
                y5=ynews[5];
                y6=ynews[6];
                y7=ynews[7];
                z0=znews[0];
                z1=znews[1];
                z2=znews[2];
                z3=znews[3];
                z4=znews[4];
                z5=znews[5];
                z6=znews[6];
                z7=znews[7];
                
               
                TriangleG(x3,y3,z3,x0,y0,z0,x5,y5,z5);
                TriangleG(x3,y3,z3,x4,y4,z4,x5,y5,z5);
                TriangleG(x6,y6,z6,x1,y1,z1,x2,y2,z2);
                TriangleG(x6,y6,z6,x7,y7,z7,x2,y2,z2);
                TriangleG(x6,y6,z6,x5,y5,z5,x7,y7,z7);
                TriangleG(x4,y4,z4,x5,y5,z5,x7,y7,z7);              
                TriangleG(x1,y1,z1,x0,y0,z0,x2,y2,z2);
                TriangleG(x0,y0,z0,x3,y3,z3,x2,y2,z2);
                TriangleG(x4,y4,z4,x2,y2,z2,x3,y3,z3);
                TriangleG(x4,y4,z4,x7,y7,z7,x2,y2,z2);
                TriangleG(x1,y1,z1,x0,y0,z0,x5,y5,z5);
                TriangleG(x1,y1,z1,x6,y6,z6,x5,y5,z5);
                }

                pageit(colors);
                clrmem(z_buffer,-127);


                asm{
                 mov ax,03
                 int 33h
                 mov done,bl
                 mov yang,cl
                 mov xang,dl
                }
                /*
                if(kbhit())
                {
                        switch(getch())
			{
                                case 0x01b:     done=1;
                                                break;
                                case 0:
                                switch(getch())
                                {
                                        case 0x50:      xang-=ROT;
                                                        break;
                                        case 0x48:      xang+=ROT;
                                                        break;
                                        case 0x4b:      yang+=ROT;
                                                        break;
                                        case 0x4d:      yang-=ROT;
                                                        break;
                                }               break;
                                case '3':       zang+=ROT;
                                                break;
                                case '1':       zang-=ROT;
                                                break;
                                case '8':       yo+=ROT;
                                                break;
                                case '2':       yo-=ROT;
                                                break;
                                case '4':       xo-=ROT;
                                                break;
                                case '6':       xo+=ROT;
                                                break;
                                case '7':       scale-=ROT;
                                                break;
                                case '9':       scale+=ROT;
                                                break;
                                case '5':       colors++;
                                                break;
                                case '.':       demo=!demo;
                                                break;
                                case '0':       xang=0;
                                                yang=0;
                                                zang=0;
                                                break;
                                case ']':       ROT++;
                                                break;
                                case '[':       ROT--;
                                if(!randnum) randnum=1;
                                                break;
                                case 'l':       aliasing=!aliasing;       
                                                break;
                                case 'k':       aeffect--;
                                                if(aeffect<2)
                                                aeffect=1;
                                                break;
                                case ';':       aeffect++;
                        }
                }  
                if(demo)
                {
                        //if(!(int)(rand()%randnum))choice=!choice;
                        //if(!(int)(rand()%randnum))choice2=!choice2;
                        //if(choice)xang++;else xang--;
                       //if(choice2)yang++;else yang--;
                       yang+=ROT;
                       xang+=ROT;
                }  */
                
	}	

        asm{
        mov ax,03h
        int 10h
        }

        farfree(double_buffer);     
}



