/* Power Render Mip Map Creation Interface */

#ifndef _PRMIPMAP_
#define _PRMIPMAP_

#ifdef __cplusplus
  extern "C" {
#endif

#define MIPMAP_SAMPLE 0                 
#define MIPMAP_AVERAGE 1
#define MIPMAP_ALL_LEVELS -1

block PR_MipMapCreate (block original, PR_UCHAR level, PR_DWORD flags, 
                       color *pal);
/* -----------------------------------------------------------------------
   Function:   PR_MipMapCreate
   Purpose:    Creates a smaller version of an image using sampling or
               pixel averaging
   Parameters: original - Original image
               level - Mip map level (1-4)
               flags - MIPMAP_SAMPLE or MIPMAP_AVERAGE
   Return:     The mipmap image
   ----------------------------------------------------------------------- */

#ifdef __cplusplus
}
#endif

#endif

