#ifndef TYPES_H
#define TYPES_H

typedef struct
{
	long x;
	long y;
} FPOINT;

typedef struct
{
    float   x, y, z;
    float   Length;
}VECTOR, LIGHT;

typedef struct
{
    BYTE Vect;
    float   ox, oy, oz;
    float   vx, vy, vz;
    long    sx, sy;
}VERTEX;

typedef struct
{
    WORD  Texture;
    VERTEX  Vertex[3];
    FPOINT  TextPt[3];
}POLYGON, BITMAPOBJ;

typedef struct
{
	long		Number_Vertices;
    VERTEX  	*Vertex;
	long		Number_Polygons;
    POLYGON 	*Polygon;

	long	Width, Height;
    long    log2Width, log2Height;

}LANDSCAPE;

typedef struct
{
    float   xAngle, yAngle, zAngle;
    float   xScale, yScale, zScale;
    float   xTrans, yTrans, zTrans;
}CAMERA;

#endif
